gitstats: Modified test-lib.sh to use ~/code/git as git dir.
[git-stats.git] / src / t / test-lib.sh
blob3b9659dbd95fdf004c16c36aa0eacf30dffe89c3
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
6 # Keep the original TERM for say_color
7 ORIGINAL_TERM=$TERM
9 # For repeatability, reset the environment to known value.
10 LANG=C
11 LC_ALL=C
12 PAGER=cat
13 TZ=UTC
14 TERM=dumb
15 export LANG LC_ALL PAGER TERM TZ
16 EDITOR=:
17 VISUAL=:
18 unset GIT_EDITOR
19 unset AUTHOR_DATE
20 unset AUTHOR_EMAIL
21 unset AUTHOR_NAME
22 unset COMMIT_AUTHOR_EMAIL
23 unset COMMIT_AUTHOR_NAME
24 unset EMAIL
25 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
26 unset GIT_AUTHOR_DATE
27 GIT_AUTHOR_EMAIL=author@example.com
28 GIT_AUTHOR_NAME='A U Thor'
29 unset GIT_COMMITTER_DATE
30 GIT_COMMITTER_EMAIL=committer@example.com
31 GIT_COMMITTER_NAME='C O Mitter'
32 unset GIT_DIFF_OPTS
33 unset GIT_DIR
34 unset GIT_WORK_TREE
35 unset GIT_EXTERNAL_DIFF
36 unset GIT_INDEX_FILE
37 unset GIT_OBJECT_DIRECTORY
38 unset SHA1_FILE_DIRECTORIES
39 unset SHA1_FILE_DIRECTORY
40 GIT_MERGE_VERBOSITY=5
41 export GIT_MERGE_VERBOSITY
42 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
43 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
44 export EDITOR VISUAL
45 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
47 # Protect ourselves from common misconfiguration to export
48 # CDPATH into the environment
49 unset CDPATH
51 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
52 1|2|true)
53 echo "* warning: Some tests will not work if GIT_TRACE" \
54 "is set as to trace on STDERR ! *"
55 echo "* warning: Please set GIT_TRACE to something" \
56 "other than 1, 2 or true ! *"
58 esac
60 # Each test should start with something like this, after copyright notices:
62 # test_description='Description of this test...
63 # This test checks if command xyzzy does the right thing...
64 # '
65 # . ./test-lib.sh
66 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
67 TERM=$ORIGINAL_TERM &&
68 export TERM &&
69 [ -t 1 ] &&
70 tput bold >/dev/null 2>&1 &&
71 tput setaf 1 >/dev/null 2>&1 &&
72 tput sgr0 >/dev/null 2>&1
73 ) &&
74 color=t
76 while test "$#" -ne 0
78 case "$1" in
79 -d|--d|--de|--deb|--debu|--debug)
80 debug=t; shift ;;
81 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
82 immediate=t; shift ;;
83 -h|--h|--he|--hel|--help)
84 help=t; shift ;;
85 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
86 verbose=t; shift ;;
87 -q|--q|--qu|--qui|--quie|--quiet)
88 quiet=t; shift ;;
89 --no-color)
90 color=; shift ;;
91 --no-python)
92 # noop now...
93 shift ;;
95 break ;;
96 esac
97 done
99 if test -n "$color"; then
100 say_color () {
102 TERM=$ORIGINAL_TERM
103 export TERM
104 case "$1" in
105 error) tput bold; tput setaf 1;; # bold red
106 skip) tput bold; tput setaf 2;; # bold green
107 pass) tput setaf 2;; # green
108 info) tput setaf 3;; # brown
109 *) test -n "$quiet" && return;;
110 esac
111 shift
112 echo "* $*"
113 tput sgr0
116 else
117 say_color() {
118 test -z "$1" && test -n "$quiet" && return
119 shift
120 echo "* $*"
124 error () {
125 say_color error "error: $*"
126 trap - exit
127 exit 1
130 say () {
131 say_color info "$*"
134 test "${test_description}" != "" ||
135 error "Test script did not set test_description."
137 if test "$help" = "t"
138 then
139 echo "$test_description"
140 exit 0
143 exec 5>&1
144 if test "$verbose" = "t"
145 then
146 exec 4>&2 3>&1
147 else
148 exec 4>/dev/null 3>/dev/null
151 test_failure=0
152 test_count=0
153 test_fixed=0
154 test_broken=0
155 test_success=0
157 die () {
158 echo >&5 "FATAL: Unexpected exit with code $?"
159 exit 1
162 trap 'die' exit
164 test_tick () {
165 if test -z "${test_tick+set}"
166 then
167 test_tick=1112911993
168 else
169 test_tick=$(($test_tick + 60))
171 GIT_COMMITTER_DATE="$test_tick -0700"
172 GIT_AUTHOR_DATE="$test_tick -0700"
173 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
176 # You are not expected to call test_ok_ and test_failure_ directly, use
177 # the text_expect_* functions instead.
179 test_ok_ () {
180 test_count=$(expr "$test_count" + 1)
181 test_success=$(expr "$test_success" + 1)
182 say_color "" " ok $test_count: $@"
185 test_failure_ () {
186 test_count=$(expr "$test_count" + 1)
187 test_failure=$(expr "$test_failure" + 1);
188 say_color error "FAIL $test_count: $1"
189 shift
190 echo "$@" | sed -e 's/^/ /'
191 test "$immediate" = "" || { trap - exit; exit 1; }
194 test_known_broken_ok_ () {
195 test_count=$(expr "$test_count" + 1)
196 test_fixed=$(($test_fixed+1))
197 say_color "" " FIXED $test_count: $@"
200 test_known_broken_failure_ () {
201 test_count=$(expr "$test_count" + 1)
202 test_broken=$(($test_broken+1))
203 say_color skip " still broken $test_count: $@"
206 test_debug () {
207 test "$debug" = "" || eval "$1"
210 test_run_ () {
211 eval >&3 2>&4 "$1"
212 eval_ret="$?"
213 return 0
216 test_skip () {
217 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
218 this_test="$this_test.$(expr "$test_count" + 1)"
219 to_skip=
220 for skp in $GIT_SKIP_TESTS
222 case "$this_test" in
223 $skp)
224 to_skip=t
225 esac
226 done
227 case "$to_skip" in
229 say_color skip >&3 "skipping test: $@"
230 test_count=$(expr "$test_count" + 1)
231 say_color skip "skip $test_count: $1"
232 : true
235 false
237 esac
240 test_expect_failure () {
241 test "$#" = 2 ||
242 error "bug in the test script: not 2 parameters to test-expect-failure"
243 if ! test_skip "$@"
244 then
245 say >&3 "checking known breakage: $2"
246 test_run_ "$2"
247 if [ "$?" = 0 -a "$eval_ret" = 0 ]
248 then
249 test_known_broken_ok_ "$1"
250 else
251 test_known_broken_failure_ "$1"
254 echo >&3 ""
257 test_expect_success () {
258 test "$#" = 2 ||
259 error "bug in the test script: not 2 parameters to test-expect-success"
260 if ! test_skip "$@"
261 then
262 say >&3 "expecting success: $2"
263 test_run_ "$2"
264 if [ "$?" = 0 -a "$eval_ret" = 0 ]
265 then
266 test_ok_ "$1"
267 else
268 test_failure_ "$@"
271 echo >&3 ""
274 test_expect_code () {
275 test "$#" = 3 ||
276 error "bug in the test script: not 3 parameters to test-expect-code"
277 if ! test_skip "$@"
278 then
279 say >&3 "expecting exit code $1: $3"
280 test_run_ "$3"
281 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
282 then
283 test_ok_ "$2"
284 else
285 test_failure_ "$@"
288 echo >&3 ""
291 # This is not among top-level (test_expect_success | test_expect_failure)
292 # but is a prefix that can be used in the test script, like:
294 # test_expect_success 'complain and die' '
295 # do something &&
296 # do something else &&
297 # test_must_fail git checkout ../outerspace
300 # Writing this as "! git checkout ../outerspace" is wrong, because
301 # the failure could be due to a segv. We want a controlled failure.
303 test_must_fail () {
304 "$@"
305 test $? -gt 0 -a $? -le 129
308 # test_cmp is a helper function to compare actual and expected output.
309 # You can use it like:
311 # test_expect_success 'foo works' '
312 # echo expected >expected &&
313 # foo >actual &&
314 # test_cmp expected actual
317 # This could be written as either "cmp" or "diff -u", but:
318 # - cmp's output is not nearly as easy to read as diff -u
319 # - not all diff versions understand "-u"
321 test_cmp() {
322 $GIT_TEST_CMP "$@"
325 # Most tests can use the created repository, but some may need to create more.
326 # Usage: test_create_repo <directory>
327 test_create_repo () {
328 test "$#" = 1 ||
329 error "bug in the test script: not 1 parameter to test-create-repo"
330 owd=`pwd`
331 repo="$1"
332 mkdir "$repo"
333 cd "$repo" || error "Cannot setup test environment"
334 "$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
335 error "cannot run git init -- have you built things yet?"
336 mv .git/hooks .git/hooks-disabled
337 cd "$owd"
340 test_done () {
341 trap - exit
342 test_results_path="/tmp/git-test-results"
344 echo "total $test_count" >> $test_results_path
345 echo "success $test_success" >> $test_results_path
346 echo "fixed $test_fixed" >> $test_results_path
347 echo "broken $test_broken" >> $test_results_path
348 echo "failed $test_failure" >> $test_results_path
349 echo "" >> $test_results_path
351 if test "$test_fixed" != 0
352 then
353 say_color pass "fixed $test_fixed known breakage(s)"
355 if test "$test_broken" != 0
356 then
357 say_color error "still have $test_broken known breakage(s)"
358 msg="remaining $(($test_count-$test_broken)) test(s)"
359 else
360 msg="$test_count test(s)"
362 case "$test_failure" in
364 # We could:
365 # cd .. && rm -fr trash
366 # but that means we forbid any tests that use their own
367 # subdirectory from calling test_done without coming back
368 # to where they started from.
369 # The Makefile provided will clean this test area so
370 # we will leave things as they are.
372 say_color pass "passed all $msg"
373 exit 0 ;;
376 say_color error "failed $test_failure among $msg"
377 exit 1 ;;
379 esac
382 # Test the binaries we have just built. The tests are kept in
383 # t/ subdirectory and are run in trash subdirectory.
384 PATH=$(pwd)/..:$PATH
385 GIT_EXEC_PATH=~/code/git
386 GIT_TEMPLATE_DIR=${GIT_EXEC_PATH}/templates/blt
387 unset GIT_CONFIG
388 unset GIT_CONFIG_LOCAL
389 GIT_CONFIG_NOSYSTEM=1
390 GIT_CONFIG_NOGLOBAL=1
391 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
393 GITPERLLIB=${GIT_EXEC_PATH}/perl/blib/lib:${GIT_EXEC_PATH}/perl/blib/arch/auto/Git
394 export GITPERLLIB
395 test -d ${GIT_EXEC_PATH}/templates/blt || {
396 error "You haven't built things yet, have you?"
399 if ! test -x ${GIT_EXEC_PATH}/test-chmtime; then
400 echo >&2 'You need to build test-chmtime:'
401 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
402 exit 1
405 . ${GIT_EXEC_PATH}/GIT-BUILD-OPTIONS
407 # Test repository
408 test=trash
409 rm -fr "$test" || {
410 trap - exit
411 echo >&5 "FATAL: Cannot prepare test area"
412 exit 1
415 test_create_repo $test
416 cd "$test"
418 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
419 for skp in $GIT_SKIP_TESTS
421 to_skip=
422 for skp in $GIT_SKIP_TESTS
424 case "$this_test" in
425 $skp)
426 to_skip=t
427 esac
428 done
429 case "$to_skip" in
431 say_color skip >&3 "skipping test $this_test altogether"
432 say_color skip "skip all tests in $this_test"
433 test_done
434 esac
435 done